/*
 * fb_parser.c -  parser for MySocials driver
 * This file is part of MSA program
 *
 * Copyright (C) 2009, 2010, 2011 - MySocials team
 *
 * MSA program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MSA program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MSA program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 */
#include "parser.h"


/*
 * Parse back url
 *
 * @param inner_req - inner request
 * @param cp - profile
 * @param data - redirect url from server
 * @param data_size - size of url
 * @param response - response in xml
 * @return 0 if login success, 1 if login failure
 */
#ifdef NOT_USE_DEFAULT_WEBAUTH_PARSER
int webauth_parser(xmlDocPtr inner_req, const struct ProfileData *cp, gchar* data, int data_size, gchar **response)
{
    gchar *begin, *end;
    if (data == NULL) {
        *response = g_strdup(MSG_AUTH_ERROR);
        return 1;
    }

    msa_debug("Received from webauth : %s", data);

    begin = strstr(data, "access_token=");
    if (!begin) {
        *response = g_strdup(MSG_AUTH_ERROR);
        return 1;
    }
    while(*begin != '=' && *begin != '\0')
        ++begin;
    if (*begin == '\0') {
        *response = g_strdup(MSG_AUTH_ERROR);
        return 1;
    }
    ++begin;
    end = strstr(begin, "&");
    if (end)
        *end='\0';
    *response = g_strconcat("<?xml version=\"1.0\"?><response><sid>",
                            begin, "</sid></response>", NULL);
    return 0;
}
#endif

